(ns wanijo.schema.routes
  (:require [compojure.core :refer [defroutes GET POST]]
            [ring.util.response :as resp]
            [wanijo.framework.view :as view]
            [wanijo.framework.form :as form]
            [wanijo.schema.domain :as domain]
            [wanijo.schema.view :as view-schema]))

(defn new! [req]
  (if (form/valid? view-schema/new-form req)
    (do
      (domain/create-new!
       (get-in req [:params :schema-name])
       (get-in req [:session :uuid]))
      (resp/redirect "/schema"))
    (view-schema/overview! req)))

(defn show-schema! [uuid session]
  (println uuid session)
  (view-schema/show-schema!
   (domain/find-by-uuid! uuid)
   session))

(defroutes routes
  (GET "/schema" [] view-schema/overview!)
  (GET "/schema/:uuid" [uuid :as req] (show-schema! uuid (:session req)))
  (POST "/schema/new" [] new!))
